#ifndef ___BAMWRITER_H___
#define ___BAMWRITER_H___

#include "GenericReadWriter.h"

class BAMWriter: public GenericReadWriter {
public:
	BAMWriter(char const * const filename) :
		GenericReadWriter(filename), file(filename) {
	}

protected:
	virtual void DoWriteProlog();
	virtual void DoWriteRead(MappedRead const * const read);
	virtual void DoWritePair(MappedRead const * const read1, MappedRead const * const read2);
	virtual void DoWriteUnmappedRead(
				MappedRead const * const read);
	virtual void DoWriteEpilog();

private:
	char const * const file;
};

#endif //___BAMWRITER_H___
